package org.kie.remote.services.rest.jaxb;

import javax.inject.Inject;
import javax.ws.rs.ext.ContextResolver;
import javax.ws.rs.ext.Provider;
import javax.xml.bind.JAXBContext;

import org.kie.api.runtime.KieSession;

/**
 * We use this class in order to use (user) classes from Kjar deployments in serialization. 
 * </p>
 * Users may send inputs to the REST API that contain instances of these classes as parameters to {@link KieSession} operations.
 */
@Provider
public class JaxbContextResolver implements ContextResolver<JAXBContext> {

    @Inject
    DynamicJaxbContext dynamicContext;

    @Override
    public JAXBContext getContext(Class<?> type) {
        return dynamicContext;
    }

}
